Search Intent


This endpoint will provide you with search intent data for up to 1,000 keywords. For each keyword that you specify when setting a task, the API will return the keyword’s search intent and intent probability. Besides the highest probable search intent, the results will also provide you with other likely search intent(s) and their probability.

Based on keyword data and search results data, our system has been trained to detect four types of search intent: informational, navigational, commercial, transactional.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. The maximum number of calls that can be sent simultaneously is limited to 30.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
keywordsarray

target keywords
required field
UTF-8 encoding
maximum number of keywords you can specify in this array: 1000;
the keywords will be converted to lowercase format

learn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article

language_namestring

full name of the language
required field if don't specify language_code
you can receive the list of available languages with their language_name by making a separate request to https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages

Note: this endpoint currently supports the following languages only:
Arabic, ar,
Chinese(Traditional), zh-TW,
Czech, cs,
Danish, da,
Dutch, nl,
English, en,
Finnish, fi,
French, fr,
German, de,
Hebrew, he,
Hindi, hi,
Italian, it,
Japanese, ja,
Korean, ko,
Malay, ms,
Norwegian(Bokmål), nb,
Polish, pl,
Portuguese, pt,
Romanian, ro,
Russian, ru,
Spanish, es,
Swedish, sv,
Thai, th,
Ukrainian, uk,
Vietnamese, vi,
Bulgarian, bg,
Croatian, hr,
Serbian, sr,
Slovenian, sl,
Bosnian, bs,
Greek, el,
Hungarian, hu,
Slovak, sk,
Turkish, tr

example:
English

language_codestring

language code
required field if don't specify language_name
you can receive the list of available languages with their language_code by making a separate request to https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages
Note: this endpoint currently supports these languages only;
example:
en

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        language_codestring

language code in a POST array
if there is no data, then the value is_nulln

        items_countinteger

the number of results returned in the items array

        itemsarray

array of items with relevant traffic estimation data

            keywordstring

target keyword in a POST array

            keyword_intentobject

search intent data relevant for the specified keyword

                labelstring

search intent name
possible values: informational, navigational, commercial, transactional

                probabilityfloat

search intent probability
1 indicates the highest probability

            secondary_keyword_intentsarray

contains objects with other possible search intents for the specified keyword

                labelstring

search intent name
possible values: informational, navigational, commercial, transactional

                probabilityfloat

search intent probability


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/dataforseo_labs/google/search_intent/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "language_code": "en",
        "keywords": [
            "login page",
            "audi a7",
            "elon musk",
            "milk store new york"
        ]
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');

$post_array = array();
// simple way to set a task
$post_array[] = array(
   "keywords" => [
      "login page",
      "audi a7",
      "elon musk",
      "milk store new york"
   ],
   "language_name" => "English"
);
try {
   // POST /v3/dataforseo_labs/google/search_intent/live
   $result = $client->post('/v3/dataforseo_labs/google/search_intent/live', $post_array);
   print_r($result);
   // do something with post result
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "keywords": [
    "login page",
    "audi a7",
    "elon musk",
    "milk store new york"
  ],
  "language_name": "English"
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/dataforseo_labs/google/search_intent/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    keywords=[
        "login page",
        "audi a7",
        "elon musk",
        "milk store new york"
    ],
    language_name="English"
)
# POST /v3/dataforseo_labs/google/search_intent/live
response = client.post("/v3/dataforseo_labs/google/search_intent/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task dataforseo_labs_google_search_intent_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                keywords = new[]
                {
                    "login page",
                    "audi a7",
                    "elon musk",
                    "milk store new york"
                },
                language_name = "English"
            });
            // POST /v3/dataforseo_labs/google/search_intent/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/dataforseo_labs/google/search_intent/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
    "version": "0.1.20221214",
    "status_code": 20000,
    "status_message": "Ok.",
    "time": "0.1285 sec.",
    "cost": 0.0014,
    "tasks_count": 1,
    "tasks_error": 0,
    "tasks": [
        {
            "id": "02271900-1535-0541-0000-2ab771deb8e2",
            "status_code": 20000,
            "status_message": "Ok.",
            "time": "0.0253 sec.",
            "cost": 0.0014,
            "result_count": 1,
            "path": [
                "v3",
                "dataforseo_labs",
                "google",
                "search_intent",
                "live"
            ],
            "data": {
                "api": "dataforseo_labs",
                "function": "search_intent",
                "se_type": "google",
                "language_code": "en",
                "keywords": [
                    "login page",
                    "audi a7",
                    "elon musk",
                    "milk store new york"
                ]
            },
            "result": [
                {
                    "language_code": "en",
                    "items_count": 4,
                    "items": [
                        {
                            "keyword": "login page",
                            "keyword_intent": {
                                "label": "navigational",
                                "probability": 0.9694191
                            },
                            "secondary_keyword_intents": null
                        },
                        {
                            "keyword": "audi a7",
                            "keyword_intent": {
                                "label": "commercial",
                                "probability": 1
                            },
                            "secondary_keyword_intents": null
                        },
                        {
                            "keyword": "elon musk",
                            "keyword_intent": {
                                "label": "informational",
                                "probability": 0.95328856
                            },
                            "secondary_keyword_intents": null
                        },
                        {
                            "keyword": "milk store new york",
                            "keyword_intent": {
                                "label": "commercial",
                                "probability": 0.49751797
                            },
                            "secondary_keyword_intents": [
                                {
                                    "label": "transactional",
                                    "probability": 0.37083894
                                },
                                {
                                    "label": "informational",
                                    "probability": 0.30781138
                                }
                            ]
                        }
                    ]
                }
            ]
        }
    ]
}